#define F_CPU 16000000
#define PARKING_LIMIT 9

#include <avr/io.h>
#include <util/delay.h>
#include "engine.h"
#include "adc.h"

void led_on(){
	unsigned int i;
	
	// setam toti pinii portului D ca pini de iesire
	DDRD = 0xFF;
	for(i=1; i<=10; i++)
	{
		PORTD = (1<<PD7);
		_delay_ms(200);
	}
}

void take_time()
{
	clear_sensors();
	front_stop(0);
	back_stop(0);
	_delay_ms(1000);
}

// ------------------------------------------------
int main(void)
{
	// senzor detectie spate
	unsigned int value1 = 0;
	// senzor detectie lateral dreapta
	unsigned int value2 = 0;
	// senzor detectie lateral stanga
	unsigned int value3 = 0;
	// senzor detectie fata
	unsigned int value4 = 0;
	
	//spatiu liber pentru a se incadra in parcare
	unsigned int parking_left = PARKING_LIMIT;
	unsigned int SENSOR_LIMIT = 100;
	
	unsigned int i, j;
	
	// autoreglare limita senzori
	unsigned int light = 0;	
	ADC_init();
	_delay_ms(500);
	while(1)
	{	
		// se ia valoarea senzorului din fata
		light=ADC_read(1);
		
		//adaugam un prag la limita de senzor
		SENSOR_LIMIT = light + 200;
		
		// se continua executia programului
		light=ADC_read(1);
		if(light < SENSOR_LIMIT)
		{
			break;
		}
		
	}
	
	// program de parcare laterala dreapta
	ADC_init();
	car_init();
	clear_sensors();
	while(1)
	{
		
		value2=ADC_read(1);
		if(value2 > SENSOR_LIMIT)
		{
			forward(200);
			back_stop(500);
			value2 = 0;
		}
		else
		{
			do
			{
				parking_left--;
				forward(200);
				back_stop(500);
				value2=ADC_read(1);
				if(value2 > SENSOR_LIMIT)
				{
					forward(200);
					back_stop(500);
					value2 = 0;
					break;
				}
			}
			while(parking_left > 0);
			
			if(parking_left == 0)
			{	
				// se schimba directia motoarelor
				take_time();
				
				for(i=0; i<3; i++)
				{
					backward_right(200);
					back_stop(500);
				}
				
				// se schimba directia motoarelor
				take_time();
				
				for(i=0; i<3; i++)
				{
					forward_left(200);
					back_stop(500);
				}
				
				// se schimba directia motoarelor
				take_time();
				
				for(i=0; i<5; i++)
				{
					backward_right(200);
					back_stop(500);
				}
				
				// se schimba directia motoarelor
				take_time();
				
				value1 = ADC_read(0);
				while(value1 < SENSOR_LIMIT)
				{
					backward_left(200);
					back_stop(500);
					value1 = ADC_read(0);
				}
				
				// se schimba directia motoarelor
				take_time();
				
				value4 = ADC_read(3);
				while(value4 < SENSOR_LIMIT)
				{
					forward_right(200);
					back_stop(500);
					value4 = ADC_read(3);
				}
				front_stop(500);
				back_stop(500);
				break;
			}
			else
			{
				parking_left = PARKING_LIMIT;
			}
			
		}
	}
	
	return 0;
}